<?php
class Vyrobce extends Super {

  protected $id;
  protected $nazev;
  protected $popis;
  protected $url = '';
  protected $logo;
  protected $stav = 1;  // default stav 

  protected $getter = array('id', 'nazev', 'popis', 'url', 'logo', 'stav');
  protected $setter = array('nazev', 'popis', 'url', 'logo', 'stav');
  public $validate = array(
  	'id'     => array('digits' => 'true'),
  	'nazev'  => array('required' => 'true', 'maxlength' => 65),
    'url'	 => array('maxlength' => 255, 'url_bezw' => 'true'),
    'logo'   => array('accept'  => 'jpg|jpeg|gif|png'),
    'stav'   => array('range' => '[0,1]' )
  );
	public $label = array(
  	'id'     => 'Id',
  	'nazev'  => 'Název',
  	'url'  	 => 'URL',
		'popis'	 => 'Popis',
    'logo' 	 => 'Logo',
    'stav' 	 => 'Stav'
  );
  public $valAll = array(
  	'id'     => true,
  	'nazev'  => true,
  	'url'  => true,
    'stav' 		 => true
  );
	public $filtry = array(
      'ID' => array(
      	'type' => 'text',
				'key'	 => 'ID',
				'sql'	 => 'num',
    		'size' => 3
    	),
      'NAZEV' => array(
      	'type' => 'text',
    		'key'	 => 'NAZEV',
    		'sql'	 => 'text',
    		'size' => 12
    	),
      'URL' => array(
      	'type' => 'text',
    		'key'	 => 'URL',
    		'sql'	 => 'text',
    		'size' => 12
    	),
      'S_NAZEV' => array(
      	'type' => 'stav',
    		'key'	 => 'STAV',
    		'sql'	 => 'num'
    	),
      'UPRAVIT' => array(
      	'type' => 'submit'
    	),
      'SMAZAT' => array(
      	'type' => 'all'
    	)
    );
  public $state_validate = array();

  function __construct() {
    /*
     * stavy:
     * 1 - aktivní
     * 2 - neaktivní
     */
    $this->state_validate[1] = $this->valAll;
    $this->state_validate[0] = $this->valAll;
    $this->table = 'VYROBCE';

  }

  public function loadById($id, $hash = false, $postRestore = false) {
    $result = dibi::query('SELECT  E.*, S.NAZEV AS S_NAZEV, S.POPIS AS S_POPIS FROM ['.$this->table.'] AS E 
    	INNER JOIN STAV AS S ON S.STAV_ID = E.STAV AND ENTITA = %s
    	WHERE E.ID = %i;', $this->table, $id);

    if (count($result) == 0) {
      throw new Appliexception(1, 'Požadovaný záznam neexistuje', 'seznam', __METHOD__.' Neexistující záznam '.$id );
    }

    $row = $result->fetch()->getArrayCopy();
    $this->setFromRow($row);
    $this->my_stav = '<div title="'.$row['S_POPIS'].'" class="block_state"> '.$row['STAV'].' - '.$row['S_NAZEV'].'</div><br />';

    if ($hash) {
      $this->hash  = $this->getHash();
    } 

    $this->myStates();

    if ($postRestore) {
      $this->setFromPost();
    }
    return $this->toArray();
  }

  public function updateLogo($logo) {
    if (!empty($logo)) {
      dibi::query('UPDATE ['.$this->table.'] SET', array('LOGO' => $logo), ' WHERE ID = %i',  $this->id);
    }
  }

  public function delete($id) {

  	$result= dibi::query('SELECT LOGO FROM ['.$this->table.'] WHERE ID = %i',$id);
  	$logo = $result->fetchSingle();
  	if (!empty($logo)) {
  		unlink(PATH_VYROBCE.$logo);
  	}
  	dibi::query('DELETE FROM ['.$this->table.'] WHERE ID = %i',$id);

  }  

	protected function beforeInsert(){
		$this->url = Tools::getUrl($this->url);
	}

	protected function beforeUpdate(){
		$this->url = Tools::getUrl($this->url);
	}

}
?>